; -----------------------------------------------------------------------------
; RetroForth for "Generic" Systems
; -----------------------------------------------------------------------------
include "macros.fasm"

format elf

extrn putchar
extrn getchar
extrn exit
extrn open
extrn close
extrn read
extrn write
extrn chmod

public main

main:
	call init_retroforth
	upop ebx
	jmp ebx
;---------------------------------------------------------------------
fname rb 256
erase_it:
	upsh fname
	embed '256 0 fill'
	next

code 'use', __use
	call erase_it
	upsh 32
	call parse
	upsh fname
	swap
	embed 'move'
	next

__nblk:	embed '#blks @ 512 *'
	ret

__file dd 0
__open:
	dup
	push 66
	push fname
	call open
	add esp, 8
	mov [__file], eax
	push 438		; 0666 in octal
	push fname
	call chmod
	drop
	add esp, 8
next
__close:
	push dword [__file]
	dup
	call close
	add esp, 4
	drop
next
code 'r', __read
	dup
	embed 'new'
	call __open
	call __nblk
	upop ebx
	push ebx
	push blk
	push dword [__file]
	call read
	add esp, 12
	call __close
	drop
next
code 'w', __write
	dup
	call __open
	call __nblk
	upop ebx
	push ebx
	push blk
	push dword [__file]
	call write
	add esp, 12
	call __close
	drop
next
code 'load', __load
	call __use
	jmp __read
code 'bye', bye
	push 0
	call exit
code 'emit', emit
	pusha
	push eax
	call putchar
	pop eax
	popa
	drop
ret
code 'key', key
	dup
	call getchar
ret
code 'type',type	        ;
	push ebx	        ;
	push ecx	        ;
	upop ecx	        ;
	upop ebx	        ;
	or ecx,ecx	        ; Is the count zero?
	jz .done	        ; If so, we can exit
.a:	push ecx	        ; store the count
	dup		        ; Duplicate it
	xor eax,eax	        ; Filter out junk bits
	mov al,[ebx]	        ; Obtain the byte to show
	inc ebx 	        ; increment to the next byte
	call emit	        ; Show the character
	pop ecx 	        ; Restore the count
	loop .a 	        ; Loop, decrementing the count
.done:	pop ecx 	        ;
	pop ebx 	        ;
next
;---------------------------------------------------------------------
include "core.asm"
